rm(list=ls())

#National Teams or Premier League?
NationalTeams=T
competition<-ifelse(NationalTeams==T, "NationalTeams","PremierLeague")
load(paste0("predictions",competition,".Rdata"))

#For Premier League: remove the predictions of the first 5 playdays of every season
if(NationalTeams==F){
summary2<-NULL
summarytemp<-NULL
for(i in 0:9){
  summarytemp<-summary[((380*i)+1):(380*(i+1)),]
  summary2<-rbind(summary2,summarytemp[-(1:50),])
  }
summary<-summary2
rm(summary2, summarytemp)
}

getPredictionSummary <- function(summary){
  predictionSummary <- NULL
  i<-1
  while(i <= ncol(summary)){
    method_name <- colnames(summary)[i]
    name_parts <- strsplit(method_name,"_")[[1]]
    if(name_parts[1]=="prob"){
      method=name_parts[2]
      decay <- as.numeric(name_parts[3])
      pH <- summary[,i+1]
      pD <- summary[,i+2]
      pA <- 1-summary[,i+1]-summary[,i+2]
      if(any(pA<0)){
        x <- 1
      }
      avReturn <- mean(1/summary[,i])
      avAcc <- mean(summary[,i])
      logLoss <- -mean(log(summary[,i]))
      maxProb <- pH
      maxProb[pD>pH] <- pD[pD>pH]
      maxProb[pA>maxProb] <- pA[pA>maxProb]
      majCorrect <- mean(abs(maxProb-summary[,i])<1e-12)
      # RPS
      RPS<-mean(((pH-(summary$outcome=="H"))^2+(pA-(summary$outcome=="A"))^2)/2)
      Brier<-mean(ifelse(summary$outcome=="H",pA^2+pD^2+pA*pD, 
                          ifelse(summary$outcome=="A",pH^2+pD^2+pH*pD, pH^2+pA^2+pH*pA)))
      predictionSummary <- rbind(predictionSummary,
                                 data.frame(method=method,decay=decay,
                                            avReturn=avReturn,
                                            avAcc=avAcc,
                                            majCorrect=majCorrect,
                                            logLoss=logLoss,
                                            RPS=RPS,
                                            Brier=Brier,
                                            stringsAsFactors=FALSE))
      i<-i+3
    }else {i<-i+1}
  }
  predictionSummary
}


# Calculate the prediction summary
predictionSummary <- getPredictionSummary(summary)
save(predictionSummary, file = paste0("predictionSummary",competition,".RData"))

#summary table: best HalfPeriod(=decay) for every model.
measure<-predictionSummary$RPS
x<-predictionSummary[order(measure),]
j<-1
methods<-data.frame(method=0,decay=0,avReturn=0, avAcc=0, majCorrect=0, logLoss=0, RPS=0, Brier=0)
for(i in 1:dim(x)[1]){
  if(!(x$method[i] %in% methods[,1])){
    methods[j,]<-x[i,]
    j<-j+1
  }
}
print(methods)


